#include "detector.h"
#include <ctype.h>

Detector::Detector(const string &aDefaultCharset):
          defaultCharset(aDefaultCharset),total(0),wins(0),pes(0)
{
}

void Detector::scan(const string &s)
{
for(string::const_iterator i=s.begin();i!=s.end();i++)
   {
   int c=(unsigned char)*i;
   if(c>=0x80 && c<=0xff)
     total++;
   if(c>=0xe0 && c<=0xff)
     wins++;
   if(c==0xd0)
     pes++;
   }
}

string Detector::getCharset() const
{
if(total>=20) // Lower bound for autodetection
  if(pes*3>=total)
    return "utf-8";
  else
    if(wins*2>=total)
      return "Windows-1251";
    else
      return "koi8-r";
else
  return defaultCharset;
}

bool Detector::isAscii() const
{
return total==0; // Only characters 0x00-0x7F
}

string canonCharset(const string &s)
{
string c;

for(string::const_iterator i=s.begin();i!=s.end();i++)
   if(*i!='-' && *i!='_')
     c+=tolower(*i);
return c;
}

bool isSameCharset(const string &cs1,const string &cs2)
{
return canonCharset(cs1)==canonCharset(cs2);
}
